/*******************************************************************************
 * Copyright (c) 2007, 2008 compeople AG and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    compeople AG - initial API and implementation
 *******************************************************************************/
package org.eclipse.riena.ui.ridgets.tree;

import java.io.Serializable;
import java.util.List;

/**
 * Defines the requirements for an object that can be used as a tree node inside
 * a <code>TreeAdapter</code>.
 */
public interface ITreeNode extends Serializable {
	
	String PROP_VALUE = "value";
	String PROP_CHILDREN = "children";

	public List<ITreeNode> getChildren();
	
	public Object getValue();
	
	public void setChildren(List<ITreeNode> children);
	
	public void setValue(Object newValue);
	
	/**
	 * Returns the parent tree node <code>ITreeNode</code> of the receiver.
	 * 
	 * @return parent
	 */
	ITreeNode getParent();
} // end interface
